/**
 * FLL - Level 0
 *
 * Project: Type
 * API Version: 0.7
 * Licenses: lgpl-2.1-or-later
 *
 * Defines pid type data.
 *
 * This is auto-included by type.h and should not need to be explicitly included.
 */
#ifndef _F_pid_h
#define _F_pid_h

#ifdef __cplusplus
extern "C" {
#endif

/**
 * An array of pids.
 *
 * Properties:
 *   - array: The array of pids.
 *   - size:  Total amount of allocated space.
 *   - used:  Total number of allocated spaces used.
 */
#ifndef _di_f_pids_t_
  typedef struct {
    pid_t *array;

    f_number_unsigned_t size;
    f_number_unsigned_t used;
  } f_pids_t;

  #define f_pids_t_initialize { 0, 0, 0 }

  #define macro_f_pids_t_initialize_1(array, size, used) { array, size, used }
  #define macro_f_pids_t_initialize_2(array, length) { array, length, length }
#endif // _di_f_pids_t_

/**
 * This holds an array of f_pids_t.
 *
 * Properties:
 *   - array: The array of pids arrays.
 *   - size:  Total amount of allocated space.
 *   - used:  Total number of allocated spaces used.
 */
#ifndef _di_f_pidss_t_
  typedef struct {
    f_pids_t *array;

    f_number_unsigned_t size;
    f_number_unsigned_t used;
  } f_pidss_t;

  #define f_pidss_t_initialize { 0, 0, 0 }

  #define macro_f_pidss_t_initialize_1(array, size, used) { array, size, used }
  #define macro_f_pidss_t_initialize_2(array, length) { array, length, length }
#endif // _di_f_pidss_t_

#ifdef __cplusplus
} // extern "C"
#endif

#endif // _F_pid_h
